var SEEDO_SESSION_CUR_AREA = "_curArea_";
var SEEDO_SESSION_CUR_CITY = "_curCity_";
var AREA_STR = "小区";
var ENT_STR = "企业";
var PLACEHOLDER_STR = "{0}";
var PLACEHOLDER_STR_UN = "{1}";
/**
 * 当前小区值 初始化
 * @param ajaxGetCurAreaUrl 获取当前小区信息的url
 * @param curDatetime 当前server端的系统时间（long类型）
 */ 
function areaSessionHandle(ajaxGetCurAreaUrl,curDatetime,isEnt){
	
	// 同步native和web的当前小区、城市、企业id和name
	doDealNative(curDatetime);
	
	var _SEESION_curArea = SessionCache.getVal(SEEDO_SESSION_CUR_AREA);
	var _SEESION_curCity = SessionCache.getVal(SEEDO_SESSION_CUR_CITY);
	
	// session值为空
	if(_SEESION_curArea == null || _SEESION_curArea.curAreaId == null){
		// 初始化值
		areaValInit(ajaxGetCurAreaUrl,curDatetime);
		_SEESION_curArea = SessionCache.getVal(SEEDO_SESSION_CUR_AREA);
		_SEESION_curCity = SessionCache.getVal(SEEDO_SESSION_CUR_CITY);
	}
	
	
	if(_SEESION_curArea != null ){
		var isArea = _SEESION_curArea.isArea;
		editPageTagArea(_SEESION_curArea,isArea);
	}
	if(_SEESION_curCity != null ){
		editPageTagCity(_SEESION_curCity);
	}
	// 修改页面上需要显示中文的地方
	editPageTag(_SEESION_curArea, _SEESION_curCity);
	
	// 修改页面上的文字描述
	editPageEntOrArea(_SEESION_curArea,isEnt);
	
	hidePage4Ent(_SEESION_curArea,isEnt);
}

/**
 * 获取native本地 当前小区、城市、企业id和name
 * 和web同步
 * @param curDatetime
 */
function doDealNative(curDatetime){
	if(WV && WV.isSupport){
		var data = "";
		try{
			data = eval(('(' + WV.getCurrentCityArea() + ')'));
		}catch (e) {
			console.log(e);
			return;
		}
		
		var isArea = false;
		var expireDays = "1";
		if(!data || data == "false"){
			return;
		}
		if(!data.curEntName || data.curEntName == ""){
			isArea = true;
		}
		SessionCache.putVal(SEEDO_SESSION_CUR_AREA,{"curAreaId":data.curAreaId,"curAreaName" : data.curAreaName, "curEntId":data.curEntId,"curEntName":data.curEntName,"isArea":isArea});
		SessionCache.setTimeout(SEEDO_SESSION_CUR_AREA,expireDays*24*60*60,curDatetime);
		SessionCache.putVal(SEEDO_SESSION_CUR_CITY,{"curCityId":data.curCityId,"curCityName" : data.curCityName});
		SessionCache.setTimeout(SEEDO_SESSION_CUR_CITY,expireDays*24*60*60,curDatetime);
	}
}

function hidePage4Ent(_SEESION_curArea,isEnt){
	var isArea = true;
	if(isEnt.toLowerCase() == "true"){
		isArea = false;
	}
	if(_SEESION_curArea != null && _SEESION_curArea.isArea != null){
		isArea = _SEESION_curArea.isArea;
	}
	$("[data-unent]").each(function(){
		if($(this).attr("data-unent") == "1" && !isArea){
			$(this).hide();
		}
	});
}

function editPageTagCity(_SEESION_curCity){
	// 修改页面中城市中文
	$(".curCityNameTile").each(function(){
		var cityName = "";
		if(_SEESION_curCity == null || _SEESION_curCity.curCityId == null || _SEESION_curCity.curCityName == null){
			var cityObj = getCurCityObj();
			cityName = cityObj.cityName;
		}
		else{
			cityName = _SEESION_curCity.curCityName;
		}
		$(this).html(cityName);
	});
}
function editPageTagArea(_SEESION_curArea,isArea){
	// 修改上方导航栏 小区名字 描述信息
	$(".curAreaNameTile").each(function(){
		if(isArea){
			$(this).html(_SEESION_curArea.curAreaName);
		}else{
			$(this).html(_SEESION_curArea.curEntName);
		}
	});
}

function editPageEntOrArea(_SEESION_curArea,isEnt){
	var isArea = true;
	if(isEnt.toLowerCase() == "true"){
		isArea = false;
	}
	if(_SEESION_curArea != null && _SEESION_curArea.isArea != null){
		isArea = _SEESION_curArea.isArea;
	}
	$("[data-aoe]").each(function(){
		var content = $(this).html();
		var rst = "";
		if(!isArea){
			content = content.replace(PLACEHOLDER_STR_UN,AREA_STR);
			rst = content.replace(PLACEHOLDER_STR,ENT_STR);
		}else{
			content = content.replace(PLACEHOLDER_STR_UN,ENT_STR);
			rst = content.replace(PLACEHOLDER_STR,AREA_STR);
		}
		$(this).html(rst);
	});
}

function editPageTag(_SEESION_curArea, _SEESION_curCity){
	
	$("[data-param]").each(function(){
		var value = "";
		var conStr = "?";
		var hrf = $(this).attr("href");
		var param = $(this).attr("data-param");
		var name = $(this).attr("data-name");
		if(!param || !hrf){
			return;
		}
		var paramArr = param.split("-");
		if(!paramArr || paramArr.length < 1){
			return;
		}
		for(var i = 0; i < paramArr.length; i++){
			if(hrf.indexOf(conStr) > 0){
				conStr = "&";
			}
			switch(paramArr[i])
			{
			case "areaId":
				if(_SEESION_curArea == null){
					break;
				}
				value = _SEESION_curArea.curAreaId;
				if(name == null || typeof name == "undefined"){
					name = "curAreaId";
				}
				$(this).attr("href",hrf + conStr + name + "=" + value);
				conStr = "&";
				break;
			case "cityId":
				if(_SEESION_curCity == null){
					break;
				}
				value = _SEESION_curCity.curCityId;
				if(name == null || typeof name == "undefined"){
					name = "curCityId";
				}
				$(this).attr("href",hrf + conStr + name +"=" + value);
				conStr = "&";
				break;
			default:
				break;
			}
				
		}
	});
}

function getCurCityObj(){
	var cityObj = {};
	cityObj.cityId = "86";
	cityObj.cityName = "杭州";
	return cityObj;
}

/**
 * 当前小区值 初始化
 * @param ajaxGetCurAreaUrl 获取当前小区信息的url
 * @param curDatetime 当前server端的系统时间（long类型）
 */  
function areaValInit(ajaxGetCurAreaUrl,curDatetime){
//		data = post("${pageContext.request.contextPath}/home/ajax-get-cur-area.action");
	data = post(ajaxGetCurAreaUrl);
	if(data == null || data.result == null){
		console.log("seesionCache中 当前小区为空");
		return ;
	}
	var curAreaId = data.result.areaId;
	var curCityId = data.result.cityId;
	var curCityName = data.result.cityName;
	var isArea = data.result.isArea;
	// 设置过期时间1天
	var expireDays = "1";
	if(isArea){
		var curAreaName = data.result.areaName;
		SessionCache.putVal(SEEDO_SESSION_CUR_AREA,{"curAreaId":curAreaId,"curAreaName" : curAreaName,"isArea":isArea});
		SessionCache.setTimeout(SEEDO_SESSION_CUR_AREA,expireDays*24*60*60,curDatetime);
	}else{
		var curEntId = data.result.entId;
		var curEntName = data.result.entName;
		SessionCache.putVal(SEEDO_SESSION_CUR_AREA,{"curAreaId":curAreaId,"curEntId":curEntId,"curEntName":curEntName,"isArea":isArea});
		SessionCache.setTimeout(SEEDO_SESSION_CUR_AREA,expireDays*24*60*60,curDatetime);
	}
	
	SessionCache.putVal(SEEDO_SESSION_CUR_CITY,{"curCityId":curCityId,"curCityName" : curCityName});
	SessionCache.setTimeout(SEEDO_SESSION_CUR_CITY,expireDays*24*60*60,curDatetime);
}