 $.fn.listGroup = function () {
            /**
             *  检测当前list的位置时是第几group
             * @param height  当前高度位置
             * @param lih     group高度位置集合
             * @returns {number}
             */
            function checkRange(height, lih) {
                var res = 0;
                for (var i = 0; i < lih.length; i++) {
                    if (height >= lih[i]) {
                        res = i;
                    } else {
                        return res;
                    }
                }
                return res;
            }
 
            /**
             *  对超出边界的判断矫正
             * @param top                 待校验坐标
             * @param listHeight          list高度
             * @param listGroupHeight     list-group高度
             * @returns {*}
             */
            function resetTop(top, listHeight, listGroupHeight) {
                if (top > 0) {
                    top = 0;
                } 
                else if(top == undefined){
                	return top;
                }
//                else if (top < listGroupHeight - listHeight) {
//                      top = listGroupHeight - listHeight;
//                }
                return top;
            }

            /**
             * 获取index序号
             * @param y 当前鼠标坐标
             * @param inxOffy 序号栏屏幕偏移
             * @returns {Number}
             */
            function getIndex(y, inxOffy) {
                var h = y - inxOffy;
                return parseInt(h / 16);
            }

            /**
             * 移动list
             * @param list  list对象
             * @param gi    显示当前group号
             * @param lih   group高度位置集合
             */
            function moveList(list, gi, lih) {
                list.css({top: -lih[gi]});
            }

            this.each(function () {
                var $this = $(this);
                var flag = $this.children(".flag");
                var $scrollList, listHeight = $this.children(".list").height(), listGroupHeight = $this.height();   //定义list对象并获取他的高度，获取list-group控件高度
                var msOldy, listOldy = 0;       // 定义前一次鼠标y坐标，前一次list y坐标
                var $lis = $this.children("ul").children();
                // 定义并生成一个存放所有group的y坐标的数组
                var lihArr = [];
                $lis.each(function () {
                    lihArr.push($(this).position().top);
                });
                $this.children(".list").bind("mousedown", function (ms) {
                    $scrollList = $(this);
                    msOldy = ms.pageY;
                });
                $this.children(".list").bind("touchstart",function(ms){
                	$scrollList = $(this);
                    msOldy = ms.originalEvent.changedTouches[0].clientY;
                });
                $(document).bind("touchmove",function(ms){
                	if ($scrollList) {            // 如果触发鼠标按下再监听鼠标移动
                        //控制list移动，随着鼠标移动，list上下移动
                		var msPageY = ms.originalEvent.changedTouches[0].clientY;
                        var msDiff = msPageY - msOldy;
                        msOldy = msPageY;
                        var scrollTop = parseInt($scrollList.css("top"));   //list y坐标高
                        var resTop = scrollTop + msDiff;   // list 随鼠标位移的结果y坐标
                        resTop = resetTop(resTop, listHeight, listGroupHeight);  //对超出边界的判断矫正
                        $scrollList.css("top", resTop);

                        var wt = checkRange(-resTop, lihArr);   // 获取当前list的位置时是第几group
                        var curLi = $scrollList.children("li").eq(wt).children(".title");  //list下当前group的title
                        var nextLi = $scrollList.children("li").eq(wt + 1).children(".title");  //list下后一个group的title

                        flag.html(curLi.html());    // flag title内容替换当前title
                        var listDiff = resTop - listOldy;
                        listOldy = resTop;
                        var flag_top = parseInt(flag.css("top")); // 获取flag的y坐标
                        if (listDiff < 0) {    //list向上走
                            var nextTity = nextLi.position().top + resTop; //下一个title的相对list坐标
                            if (flag_top <= -19) {           //flag在这个范围内时定在listgroup头部
                                flag.css("top", 0);
                            }
                            if (0 < nextTity && nextTity < 20) { //下一个title在这个范围内时flag向上移动
                                flag.css("top", flag_top + listDiff);

                            } else {
                                flag.css("top", 0);
                            }
                        } else if (listDiff > 0) { //list 向下走
                            var nextTity = nextLi.position().top + resTop;
                            if (flag_top >= 0) {
                                flag.css("top", -20);
                                flag_top = -20;
                            }
                            if (0 < nextTity && nextTity < 20) {
                                flag.css("top", flag_top + listDiff);
                            } else {
                                flag.css("top", 0);
                            }
                        }
                    }
                });
                $(document).bind("mousemove", function (ms) {
                    if ($scrollList) {            // 如果触发鼠标按下再监听鼠标移动
                        //控制list移动，随着鼠标移动，list上下移动
                        var msDiff = ms.pageY - msOldy;
                        msOldy = ms.pageY;
                        var scrollTop = parseInt($scrollList.css("top"));   //list y坐标高
                        var resTop = scrollTop + msDiff;   // list 随鼠标位移的结果y坐标
                        resTop = resetTop(resTop, listHeight, listGroupHeight);  //对超出边界的判断矫正
                        $scrollList.css("top", resTop);

                        var wt = checkRange(-resTop, lihArr);   // 获取当前list的位置时是第几group
                        var curLi = $scrollList.children("li").eq(wt).children(".title");  //list下当前group的title
                        var nextLi = $scrollList.children("li").eq(wt + 1).children(".title");  //list下后一个group的title

                        flag.html(curLi.html());    // flag title内容替换当前title
                        var listDiff = resTop - listOldy;
                        listOldy = resTop;
                        var flag_top = parseInt(flag.css("top")); // 获取flag的y坐标
                        if (listDiff < 0) {    //list向上走
                            var nextTity = nextLi.position().top + resTop; //下一个title的相对list坐标
                            if (flag_top <= -29) {           //flag在这个范围内时定在listgroup头部
                                flag.css("top", 0);
                            }
                            if (0 < nextTity && nextTity < 30) { //下一个title在这个范围内时flag向上移动
                                flag.css("top", flag_top + listDiff);

                            } else {
                                flag.css("top", 0);
                            }
                        } else if (listDiff > 0) { //list 向下走
                            var nextTity = nextLi.position().top + resTop;
                            if (flag_top >= 0) {
                                flag.css("top", -30);
                                flag_top = -30;
                            }
                            if (0 < nextTity && nextTity < 30) {
                                flag.css("top", flag_top + listDiff);
                            } else {
                                flag.css("top", 0);
                            }
                        }
                    }
                });
                $(document).bind("mouseup", function () {
                    $scrollList = false;
                });
                // 如果需要index栏
                if ($this.attr("data-index") == "show") {
                    // 动态生成index栏并添加到尾部
                    var $index = $("<div class='index'></div>");
                    var bArr = [];
                    var $titles = $this.children(".list").find(".title");
                    for (var i = 0; i < $titles.length; i++) {
                        bArr.push("<b>" + $titles.eq(i).html() + "</b>");
                    }
                    $index.append(bArr.join(""));
                    $this.append($index);

                    var scrollIndex;// 是否正在滚动index
                    $index.bind("mousedown", function (ms) {
                        scrollIndex = true;
                        var index = getIndex(ms.pageY, indexOffsetY);     // 得到当前组序号
                        var bi = $index.children("b").eq(index).html();  // 获取当前组title内容
                        flag.html(bi);
                        moveList($this.children(".list"), index, lihArr);   // 移动list到显示当前组
                    });
                    var indexOffsetY = $index.offset().top;
                    $(document).bind("mousemove", function (ms) {
                        if (scrollIndex) {
                            var index = getIndex(ms.pageY, indexOffsetY);
                            var bi = $index.children("b").eq(index).html();
                            flag.html(bi);
                            moveList($this.children(".list"), index, lihArr);
                        }
                    });
                    $(document).bind("mouseup", function () {
                        scrollIndex = false;
                    });
                }
            });
        }
    