var keybord = function(){
	return {
		"init" : function(fnCallback){
			/*
			 * 绑定数字键盘
			 */
			bindNumKey2PwDiv(fnCallback);
			
			/*
			 * 绑定del键
			 */
			bindDelKey2PwDiv();
		},
		"setFunction" : function(fn){
			/*
			 * 解除原数字键盘绑定事件
			 */
			unBindNumKey2PwDiv();
			
			/*
			 * 重新绑定数字键盘
			 */
			bindNumKey2PwDiv(fn);
		}
	};
}();

/**
 * 为数字键盘绑定事件
 * @param fnCallback	6位密码输入校验完成后 回调函数
 */
/*点击次数*/
var clickCount = 0;

function bindNumKey2PwDiv(fnCallback){
	var numBtObj = $("div[id *= 'num']");
	numBtObj.click(function(){
		if(clickCount > 5){
			return;
		}
		clickCount++;
		
		var num = this.innerText;
		for(var i = 1; i < 7; i++){
			var curPwd = $("input[id = 'pwd-"+i+"']").val();
			if( curPwd == null || curPwd == undefined){
				console.log("curPwd is null or undefined");
				return;
			}
			
			/*
			 * 查询可以用作输入的div
			 */
			if(curPwd == ""){
				var iconCls = "<i class='icon-circle'></i>";
				
				$("div[id = 'pwd-"+i+"'] > span").html(iconCls);
				$("input[id = 'pwd-"+i+"']").attr("value",num);
				
				/*
				 * 输入最后一位后 获取6位密码值 并作格式校验
				 */
				if(i == 6){
//					unBindNumKey2PwDiv();
					inter = setInterval(function(){
						var pwdStr = getPwdValue();
						
						isOk = fnCallback.call(this,pwdStr);
						if(isOk){
							reSetData();
							modalPwd.close();
							return;
						}
						reSetData();
						modalPwd.open();
					}, 50);
				}
				return;
			}
		}
	});
}

/**
 * 为del键绑定事件
 */
function bindDelKey2PwDiv(){
	var delBtObj = $("#del");
	delBtObj.click(function(){
		for(var i = 6; i > 0; i--){
			var curPwdObj = $("input[id = 'pwd-"+i+"']");
			var curPwdVal = curPwdObj.val();
			if( curPwdVal == null || curPwdVal == undefined){
				console.log("curPwdVal is null or undefined");
				return;
			}
			if(curPwdVal == ""){
				continue;
			}
			$("div[id = 'pwd-"+i+"'] > span").text("");
			curPwdObj.val("");
			clickCount --;
			return;
		}
	});
}

/**
 * 获取6位密码 并校验格式
 * @returns	格式正确返回 密码		否则返回false
 */
function getPwdValue(){
	var pwdStr = "";
	for(var i = 1; i < 7; i++){
		var pwdInputObj = $("input[id = 'pwd-"+i+"']");
		pwdStr += pwdInputObj.val();
	}
	var pwdRegExp = /^\d{6}$/;
	if(pwdRegExp.exec(pwdStr)){
		return pwdStr;
	}
	return false;
}

/**
 * 重置密码输入框
 */
function reSetData(){
	for(var i = 1; i < 7; i++){
		$("div[id = 'pwd-"+i+"'] > span").html("");
		$("input[id = 'pwd-"+i+"']").attr("value","");
	}
	window.clearInterval(inter);
	
	clickCount = 0;
}

/**
 * 解除对输入密码按键的事件绑定
 */
function unBindNumKey2PwDiv(){
	var numBtObj = $("div[id *= 'num']");
	numBtObj.each(function(){
		$(this).unbind("click");
	});
}
