var modalPwd = function(){
	return {
		/**
		 * 密码输入页面初始化
		 * @param {Boolean}	 isQuickClose	是否支持快速关闭
		 */
		"init" : function(isQuickClose,href){
			var title = "";
			
			/*
			 * 更新Divhtml
			 */
			updateDiv(title,isQuickClose);
			
			/*
			 * 这里是把inputHtml 输出到界面
			 */
//			createHtml(content,amount);
			
			/*
			 * 绑定密码输入事件
			 */
//			bind2KeyUp(fnCallback);
			
			/*
			 * 初始化 modal 模态框
			 */
			modalPwdInit(isQuickClose,href);
		},
		"setContent" : function(content){
			var boxHeight = $("#box-bg").height();
			var initObj = $("#modal_init");
			var contentObj = $("#content");
			var contentHtml 	= "<div id = 'content'><h4>"+content+"</h4></div>";
			/*
			 * content不为空 则 显示content栏 并更新content中的 文字
			 */
			if(content != null && content != ""){
				contentObj.show();
				
				if(contentObj != null && contentObj.length>0){
					$("#content > h4").html(content);
				}else{
					initObj.after(contentHtml);
				}
			}
			/*
			 * 为空 则直接隐藏该栏 
			 */
			else{
				if(contentObj != null){
					contentObj.hide();
				}
			}
//			boxHeight = boxHeight + 20;
			$("#box-bg").height(boxHeight + 20);
		},
		"setAmount" : function(amount){
			var initObj = $("#modal_init");
			var amountObj = $("#amount");
			var amountHtml 		= "<div id = 'amount'><h4>"+amount+"</h4></div>";
			
			/*
			 * amount不为空 则 显示amount栏 并更新amount中的 文字
			 */
			if(amount != null && amount != ""){
				amountObj.show();
				
				if(amountObj != null && amountObj.length>0){
					$("#amount > h4").html(amount);
				}else{
					initObj.after(amountHtml);
				}
			}
			/*
			 * 为空 则直接隐藏该栏 
			 */
			else{
				if(amountObj != null){
					amountObj.hide();
				}
			}
		},
		"setFunction" : function(fn){
			/*
			 * 解除初始化绑定的方法
			 */
			unBind2KeyUp();
			/*
			 * 重新绑定方法
			 */
			bind2KeyUp(fn);
		},
		"setTitle" : function(title){
			$("#pwdTitle").html(title);
		},
//		"setHref" : function(href){
//			
//		},
		"open" : function(){
			modalPwd.reSetData();
			$("#modal_init").click();
			$("#modal_init2").click();
			goTop();
		},
		/**
		 * 关闭窗口
		 */
		"close" : function(){
			colseModal();
			this.reSetData();
			return;
		},
		/**
		 * 初始化输入数据
		 */
		"reSetData" : function(){
			var pwdObj = $("input[id*='pwd']");
			for(var i=0;i<pwdObj.length;i++){
				pwdObj[i].value="";
			}
		}
	};
}();

/**
 * 解除绑定密码输入事件
 */
function unBind2KeyUp(){
	$("input[id*='pwd']").each(function(){
		$(this).unbind("keyup");
	});
}

/**
 * 绑定密码输入事件
 */
function bind2KeyUp(fnCallback){
	
//	$("input[id*='pwd']").each(function(){
//		$(this).keyup(function(){
//			
//			var id = $(this).attr("id");
//			var count = id.split("-")[1];
//			var childCount = parseInt(count)+1;
//			var isOk = true;
//			if(count == 6){
//				$("#pwd-"+count).blur();
//				$("#pwd-"+count).attr("type","password");
//				$("#pwd-"+count).attr("readOnly","readonly");
//				/*
//				 * 输入完密码后调用自定义方法
//				 */
//				isOk = fnCallback.call(this,getPwd());
//				if(isOk){
//					colseModal();
//					return;
//				}
//				modalPwd.reSetData();
//				modalPwd.open();
//			}
//			else{
//				$("#pwd-"+childCount).attr("type","tel");
//				$("#pwd-"+childCount).removeAttr("readonly");
//				$("#pwd-"+childCount).focus();
//				$("#pwd-"+count).attr("type","password");
//				$("#pwd-"+count).attr("readOnly","readonly");
//			}
//		});
//	});
}

/**
 * 关闭模态框
 */
function colseModal(){
	$("a[rel*='rs-dialog']").each(function(){
		var trigger 	= $(this);
		var rs_dialog 	= $('#' + trigger.data('target'));
		var rs_overlay 	= $('.rs-overlay');
		if( !rs_dialog.length ) return true;
		rs_dialog.removeClass('in').delay(150).queue(function(){
			rs_dialog.hide().dequeue();	
			rs_overlay.fadeOut('slow');
			$('html').removeClass('dialog-open');
			$('body').css('padding-right', '');	
			modalPwd.reSetData();
		});
	});
}

/**
 * 初始化 modal 模态框
 */
function modalPwdInit(isQuickClose,href){
	$('body').append('<div class="rs-overlay" />');
	$("a[rel='rs-dialog']").each(function(){
		var trigger 	= $(this);
		var rs_dialog 	= $('#' + trigger.data('target'));
		var rs_box 		= rs_dialog.find('.rs-dialog-box');
		var rs_close 	= rs_dialog.find('.close');
		var rs_overlay 	= $('.rs-overlay');
		if( !rs_dialog.length ) return true;
		
		// Open dialog
		trigger.click(function(){
			//Get the scrollbar width and avoid content being pushed
			var w1 = $(window).width();
			$('html').addClass('dialog-open');
			var w2 = $(window).width();
			c = w2-w1 + parseFloat($('body').css('padding-right'));
			if( c > 0 ) $('body').css('padding-right', c + 'px' );

			rs_overlay.fadeIn('fast');
			rs_dialog.show( 'fast', function(){
				rs_dialog.addClass('in');
			});	
			return false;
		});
		if(isQuickClose){
			// Close dialog when clicking on the close button
			rs_close.click(function(e){
				rs_dialog.removeClass('in').delay(150).queue(function(){
					rs_dialog.hide().dequeue();	
					rs_overlay.fadeOut('slow');
					$('html').removeClass('dialog-open');
					$('body').css('padding-right', '');	
					modalPwd.reSetData();
				});
				return false;
			});
			
			// Close dialog when clicking outside the dialog
			rs_dialog.click(function(e){
				rs_close.trigger('click');		
			});
			rs_box.click(function(e){
				e.stopPropagation();
			});
		}
	});
	
	
	/*keybord*/
	$("a[rel='rs-dialog-keybord']").each(function(){
		var trigger 	= $(this);
		var rs_dialog 	= $('#' + trigger.data('target'));
		var rs_box 		= rs_dialog.find('.rs-dialog-box-keybord');
		var rs_close 	= rs_dialog.find('.close');
		var rs_overlay 	= $('.rs-overlay');
		if( !rs_dialog.length ) return true;

		// Open dialog
		trigger.click(function(){
			//Get the scrollbar width and avoid content being pushed
			var w1 = $(window).width();
			$('html').addClass('dialog-open');
			var w2 = $(window).width();
			c = w2-w1 + parseFloat($('body').css('padding-right'));
			if( c > 0 ) $('body').css('padding-right', c + 'px' );

			rs_overlay.fadeIn('fast');
			rs_dialog.show( 'fast', function(){
				rs_dialog.addClass('in');
			});	
			return false;
		});
		if(isQuickClose){
			// Close dialog when clicking on the close button
			rs_close.click(function(e){
				rs_dialog.removeClass('in').delay(150).queue(function(){
					rs_dialog.hide().dequeue();	
					rs_overlay.fadeOut('slow');
					$('html').removeClass('dialog-open');
					$('body').css('padding-right', '');	
					modalPwd.reSetData();
					
					
					
				});
				return false;
			});
			
			// Close dialog when clicking outside the dialog
			rs_dialog.click(function(e){
				modalPwd.close();
				rs_close.trigger('click');		
			});
			rs_box.click(function(e){
				e.stopPropagation();
			});
		}
		
		/**/
		else{
			rs_dialog.click(function(e){
				modalPwd.close();
				top.location.href = href;
				rs_close.trigger('click');		
			});
			rs_box.click(function(e){
				e.stopPropagation();
			});
		}
	});
}

/**
 * 创建初始化input页面
 */
//function createHtml(content,amount){
//	var initHtml		= "<a id ='modal_init' href='#' rel='rs-dialog' data-target='myModal'></a>";
//	var initHtml2		= "<a id ='modal_init2' href='#' rel='rs-dialog2' data-target='myModal2'></a>";
//	
//	var contentHtml 	= "<div id = 'content'><h4>"+content+"</h4></div>";
//	var amountHtml 		= "<div id = 'amount'><h4>"+amount+"</h4></div>";
//	
//	var divCls			= "class='col-md-2 col-sm-2 col-xs-2 sudoku-padding-square-pwd'";
//	var inputCls 		= "class='col-md-12 col-sm-12 col-xs-12 ime-disabled pwd'";
//	var inputAttr 		= "id='pwd-";
//	var inputAttrEnd 	= "' type='text' maxLength='1' value='' readonly/></div>";
//	
//	var appendHtml 		= "";
//	
//	var initObj = $("#modal_init");
//	
//	/*
//	 * 判断是否已经初始化过 如果初始化过则只做更新 否则就初始化
//	 */
//	if(initObj == null || initObj.length == 0){
//		
//		/*
//		 * 这里是把inputHtml 输出到界面
//		 */
//		
//		for(var i = 1;i <= 6;i++){
//			appendHtml = appendHtml + "<div " + divCls + ">"
//			+ "<input " + inputCls + inputAttr + i + inputAttrEnd;
//		}
//		if(amount != null && amount != ""){
//			appendHtml = amountHtml + appendHtml;
//		}
//		if(content != null && content != ""){
//			appendHtml = contentHtml + appendHtml;
//		}
//		$("#pwdInput").append(initHtml + initHtml2 + appendHtml);
//		
//		return;
//	}
//	
//	var contentObj = $("#content");
//	var amountObj = $("#amount");
//	
//	/*
//	 * amount不为空 则 显示amount栏 并更新amount中的 文字
//	 */
//	if(amount != null && amount != ""){
//		amountObj.show();
//		
//		if(contentObj != null){
//			$("#amount > h4").html("￥"+amount);
//		}else{
//			initObj.after(amountHtml);
//		}
//	}
//	/*
//	 *为空 则直接隐藏该栏 
//	 */
//	else{
//		if(amountObj != null){
//			amountObj.hide();
//		}
//	}
//	/*
//	 * content不为空 则 显示content栏 并更新content中的 文字
//	 */
//	if(content != null && content != ""){
//		contentObj.show();
//		
//		if(contentObj != null){
//			$("#content > h4").html(content);
//		}else{
//			initObj.after(contentHtml);
//		}
//	}
//	/*
//	 *为空 则直接隐藏该栏 
//	 */
//	else{
//		if(contentObj != null){
//			contentObj.hide();
//		}
//	}
//}

function updateDiv(title,isQuickClose){
	var closeHtml 	= "<a class='close' href='#'>&times;</a>";
	var headObj = $(".rs-dialog-header");
	var titleObj = $("#pwdTitle");
	if(isQuickClose){
		headObj.before(closeHtml);
	}
	if(title == "" || title == null || title.length < 1){
		return;
	}
	titleObj.html(title);
	
}

/**
 * 创建Divhtml
 * @param title DIV 标题头
 * @param isQuickClose 是否支持快速关闭
 */
function createDiv(title,isQuickClose){
	var divHtml 	= "<div class='rs-dialog-box'>";
	var closeHtml 	= "<a class='close' href='#'>&times;</a>";
	var divHtml2	= "<div class='rs-dialog-header'><h3 id='pwdTitle' style='text-align: center;'>";
	var divHtml3 	= "</h3></div><div class='rs-dialog-body'><div class='sudoku' style='margin-bottom: 0px'><div class='list-group'>";
	var divHtml4 	= "<div class='list-group-item  panel-height-big'><div id ='pwdInput'></div></div></div></div></div>";
	var divHtml5 	= "<div class='rs-dialog-footer'></div></div>";
	
	var appendHtml = divHtml;
	
	if(isQuickClose){
		appendHtml += closeHtml;
	}
	
	appendHtml += divHtml2;
	
	if(title != "" || title != null){
		appendHtml += title;
	}
	
	appendHtml = appendHtml + divHtml3 + divHtml4 + divHtml5;
	
	$("#myModal").html(appendHtml);
}
/**
 * 返回页面顶部 用于拉出数字键盘 界面上移
 */
function goTop(){
	window.scrollTo(0,0);
}

/**
 * 获取密码
 * @returns 通过则返回输入密码 否则为false
 */
function getPwd(){
	var pwd = "";
	for(var i = 1;i <= 6;i++){
		pwd = pwd + $("#pwd-" + i).val();
	}
	var pwdRegExp = /^\d{6}$/;
	if(pwdRegExp.exec(pwd)){
		return pwd;
	}
	return false;
}