/**
 * App 通知
 */

var _notifiArr = new Array();
var _notifiPageArr = new Array();
var _contextPath = "";

var _notifiTag = "data-notf";
var _notifiPoint = "1";
var _notifiNum = "3";
var _notifiSquare = "2";
var _notifiSquareStr = "square";
var _notifiPointStr = "point";
var _notifiNumStr = "num";

/**
 * 初始化通知
 */
function initNotifi(contextPath) {
	_contextPath = contextPath;
	initNotifiArr(_contextPath + "notification/ajax-get-notification.action");
	handlePageNotifi();
}

/**
 * 初始化通知数组
 * 
 * @param url
 */
function initNotifiArr(url) {
	var curAreaObj = SessionCache.getVal(SEEDO_SESSION_CUR_AREA);
	var curCityObj = SessionCache.getVal(SEEDO_SESSION_CUR_CITY);
	if(!curAreaObj || !curCityObj || !curAreaObj.curAreaId || !curCityObj.curCityId ){
		return;
	}
	var curEntId = 0;
	
	if(curAreaObj.curEntId){
		curEntId = curAreaObj.curEntId;
	}
	var notice = new Notice(null,curCityObj.curCityId,curAreaObj.curAreaId,curEntId);
	data = post(url, {
		"notice.provincialId" : notice.provincialId,
		"notice.cityId" : notice.cityId,
		"notice.areaId" : notice.areaId,
		"notice.entId" : notice.entId
	});
	if (data && data.result) {
		for (i in data.result) {
			_notifiArr.push(data.result[i]);
		}
	}
}

/**
 * 处理页面上的通知标签
 */
function handlePageNotifi() {
	$("a[" + _notifiTag + "]").each(function() {
		handleEachCss(this);
	});
}

/**
 * 对每个通知标签的点击事件做处理
 */
function handleEachClk(noticeId, obj){
	$(obj).click(function(){
		data = post(_contextPath + "notification/ajax-read-notification.action", {
			"notice.id" : noticeId
		});
//		if (data && data.result && (data.result.isSuccess == "true" || data.result.isSuccess)) {
//			
//		}
	});
}

/**
 * 对每个通知标签的样式做处理
 */
function handleEachCss(obj) {
	var notifi_count = 0;
	var notifiContext = $(obj).attr(_notifiTag);
	// 返回含有 内容和样式的obj
	var notifiContextObj = handleNotifiStyle(notifiContext);
	if (notifiContextObj == null) {
		return;
	}
	var isShow = false;
	
	for(var i in _notifiArr){
		if(!_notifiArr[i].cssContext){
			continue;
		}
		if(_notifiArr[i].cssContext.indexOf(notifiContextObj.content) >= 0){
			notifi_count ++;
			// 是否为最底层
			if(_notifiArr[i].cssContext == notifiContextObj.content){
				handleEachClk(_notifiArr[i].id, obj);
			}
			isShow = true;
		}
	}
	
	if(!isShow){
		return;
	}
	
	var cssStr = "i-notf-"+notifiContextObj.style;
	var font = "";

	switch (notifiContextObj.style) {
	case _notifiPointStr:
		break;
	case _notifiSquareStr:
		font = "新消息";
		break;
	case _notifiNumStr:
		font = notifi_count;
		break;
	default:
		break;
	}
	$("<i class = '" + cssStr + " " + cssStr + "_" + notifiContextObj.content + "'>" + font + "</i>").appendTo(obj);
}

/**
 * 处理标签中的通知形状
 * 
 * @param notifiContext
 */
function handleNotifiStyle(notifiContext) {
	var notifiContextObj = null;
	if (!notifiContext) {
		console.log("未设置样式 notifiContext为空");
		return notifiContextObj;
	}
	var notifiContextArr = notifiContext.split("_");
	if (notifiContextArr.length < 2) {
		console.log("notifiContext: " + notifiContext + " |样式设置错误");
		return notifiContextObj;
	}
	var styleStr = notifiContextArr[0];
	var content = notifiContext.replace(styleStr + "_", "");
	notifiContextObj = new NotifiContextObj(content, styleStr);
	return notifiContextObj;
}

/**
 * 通知标签转换后的对象
 */
function NotifiContextObj(content, style) {
	this.content = content;
	this.style = style;
}

/**
 * 通知对象的构造函数
 */
function Notice(provincialId, cityId, areaId, entId){
	this.provincialId = provincialId;
	this.cityId = cityId;
	this.areaId = areaId;
	this.entId = entId;
}

/**
 * 后台传回来的通知详情的构造函数
 */
function NoticeInfo(expireTime, noticeContext, cssContext, noticeStyle) {
	this.expireTime = expireTime;
	this.noticeContext = noticeContext;
	this.cssContext = cssContext;
	this.noticeStyle = noticeStyle;
}