/**
 * 初始化权限配置文件
 * @param url
 */
function initAuthorityConfig(baseUrl){
	/**
	 * json格式说明
	 * 
	 * auth_key		: 权限的key
	 * auth_value	: 权限的值
	 * auth_limit	: 是否做权限限制 1:限制 2:不限制
	 */
	
	var jsonUrl = "js/componets/authority/authorityConfig.json";
	
	$.getJSON(baseUrl + jsonUrl, function(data){
		// 处理锁的权限控制
		doDealLock(data, baseUrl);
		
	});
}

/**
 * 处理锁的权限控制
 * @param data
 */
function doDealLock(data, baseUrl){
	
	var KEY_LOCK = "lock";
	var LIMIT_VALUE = "1";
	
	var curUrl = top.location.href;
	for(var val in data){
		if(data && data[val] && data[val].auth_key === KEY_LOCK 
				&& data[val].auth_limit === LIMIT_VALUE){
			if(curUrl.indexOf(data[val].auth_value) > -1){
				doDealLockNotAllow(baseUrl);
			}
		}
	}
}


/**
 * 没有钥匙权限不允许访问的处理方法
 */
function doDealLockNotAllow(baseUrl){
	var _SEESION_curArea = SessionCache.getVal(SEEDO_SESSION_CUR_AREA);
	var jumpUrl = baseUrl + "home/check/check-lock-type.action";
	
	if(_SEESION_curArea == null || _SEESION_curArea.curAreaId == null){
		top.location.href = jumpUrl;
		return;
	}
	
	var hasKey = true;
	if(WV && WV.isSupport){
		var str = WV.hasKey();
		if(str != "1"){
			hasKey = false;
		}
	}
	
	var curAreaId = _SEESION_curArea.curAreaId;
	var curEntId = _SEESION_curArea.curEntId;
	var data = post(baseUrl + "home/ajax-get-qcodeV20",{"areaId":curAreaId,"entId":curEntId});
	if((!data || typeof(data) == "undefined" || !data.result) && !hasKey){
		top.location.href = jumpUrl;
	}
}