var Navigation = (function(){
	
	CSS_DEFAULT = 		"nav";
	CSS_TITLE = 		"-title";
	CSS_ELE = 			"-ele";
	CSS_ELE_LEFT = 		"-left";
	CSS_ELE_RIGHT =		"-right";
	CSS_ELE_ACTIVE = 	"active";
	
	KEY_NAV_TITLE = 	"data-nav-title";
	KEY_NAV_ACTIVE = 	"data-nav-isAct";
	KEY_NAV_TARGET_ID = "data-nav-tarId";
	KEY_NAV_ITEM = 		"data-nav-item";
	
	BLANK_PERCENT = 	1/4;
	
	this.navObj;
	this.tempHtml;
	/**
	 * 组件调用方法构造函数
	 */
	var NavigationFun = function(){};
	
	/**
	 * 组建初始化
	 * @param name	导航栏名称
	 * @param css	样式
	 */
	NavigationFun.prototype.init = function(name, css){
		var $obj = getNavJqObj(name);
		var eleObjArr = getNavEleObjArr($obj);
		var size = eleObjArr.length;
		var navObj = new NavObj(name, css, size, eleObjArr, $obj);
		setNavObj(navObj);
		return this;
	};
	
	/**
	 * 渲染处理
	 */
	NavigationFun.prototype.rander = function(){
		// 视图渲染
		viewRander();
		// 数据渲染
		modelRander();
		// 事件绑定
		bindEvent();
	};
	
	/**
	 * 视图渲染
	 */
	var viewRander = function(){
		// 处理样式
		doDealCss2Ele();
		doDealCss2Title();
		// 处理完所有视图后 显示导航栏
		showAllNavEle();
	};
	
	/**
	 * 数据渲染
	 */
	var modelRander = function(){
		doDealNavEle();
	};
	
	/**
	 * 事件绑定
	 */
	var bindEvent = function(){
		// 绑定导航栏元素点击事件
		doBindClk2Ele();
	};
	
	/**
	 * 绑定导航栏元素的点击事件
	 */
	var doBindClk2Ele = function(){
		for(var i in navObj.eleObjArr){
			var thisEleObj = navObj.eleObjArr[i].$obj;
			thisEleObj.click(function(){
				clearAllActive();
				$(this).addClass(CSS_ELE_ACTIVE);
				hideAllTarget();
				showTargetItem($(this).attr(KEY_NAV_TARGET_ID));
			});
		}
		
	};
	
	/**
	 * 处理导航栏元素的第一次显示
	 */
	var doDealNavEle = function(){
		for(var i in navObj.eleObjArr){
			if(navObj.eleObjArr[i].isActive){
				hideAllTarget();
				showTargetItem(navObj.eleObjArr[i].targetId);
			}
		}
	};
	
	/**
	 * 处理导航栏元素的样式
	 */
	var doDealCss2Ele = function(){
		// 导航栏元素数量
		var arrLength = navObj.eleObjArr.length;
		// 屏幕宽度
		var screenW = document.body.clientWidth;
		// 两边空白宽度
		var blankW = screenW * BLANK_PERCENT;
		// 导航栏元素宽度
		var eleW = (screenW - blankW)/arrLength;
		// left属性
		var leftW = blankW / 2;
		// 偏移量
		for(var i in navObj.eleObjArr){
			var deviationW = 1;
			var thisEleObj = navObj.eleObjArr[i].$obj;
			// 第一个元素
			if(i == 0){
				deviationW = 2;
				thisEleObj.addClass(navObj.css + CSS_ELE + CSS_ELE_LEFT);
			}
			// 最后一个元素
			if(i == arrLength-1){
				thisEleObj.addClass(navObj.css + CSS_ELE + CSS_ELE_RIGHT);
			}
			// 是否为激活元素
			if(navObj.eleObjArr[i].isActive){
				thisEleObj.addClass(CSS_ELE_ACTIVE);
			}
			thisEleObj.addClass(navObj.css + CSS_ELE);
			thisEleObj.width(eleW/screenW*100-deviationW + "%");
			thisEleObj.css("left",leftW/screenW*100 + "%");
			leftW += eleW;
		}
	};
	
	/**
	 * 显示所有的导航栏元素
	 */
	var showAllNavEle = function(){
		for(var i in navObj.eleObjArr){
			navObj.eleObjArr[i].$obj.show();
		}
	};
	
	/**
	 * 清除所有激活的标志
	 */
	var clearAllActive = function(){
		for(var i in navObj.eleObjArr){
			var thisEleObj = navObj.eleObjArr[i].$obj;
			thisEleObj.removeClass(CSS_ELE_ACTIVE);
		}
	};
	
	/**
	 * 隐藏所有目标元素
	 */
	var hideAllTarget = function(){
		for(var i in navObj.eleObjArr){
			$("#" + navObj.eleObjArr[i].targetId).hide();
		}
	};
	
	/**
	 * 显示目标元素
	 */
	var showTargetItem = function(targetId){
		$("#" + targetId).show();
	};
	
	/**
	 * 处理title的样式
	 */
	var doDealCss2Title = function(){
		navObj.$obj.addClass(navObj.css + CSS_TITLE);
	};
	
	/**
	 * 获取jquery对象
	 */
	var getNavJqObj = function(name){
		return $("div[" + KEY_NAV_TITLE + "='" + name + "']");
	};
	
	/**
	 * 获取导航栏对象数组
	 */
	var getNavEleObjArr = function($obj){
		var tempArr = new Array();
		$obj.children().each(function(){
			var name = $(this).text();
			var targetId = $(this).attr(KEY_NAV_TARGET_ID);
			var isActive = $(this).attr(KEY_NAV_ACTIVE) == undefined ? false : true;
			tempArr.push(new NavEleObj(name, targetId, isActive, $(this)));
		});
		return tempArr;
	};
	
	var setNavObj = function(navObj){
		this.navObj = navObj;
	};
	
	/**
	 * 导航栏元素的构造函数
	 */
	var NavEleObj = function(name, targetId, isActive, $obj){
		this.name = name;
		this.targetId = targetId;
		this.isActive = isActive;
		this.$obj = $obj;
	};
	
	var NavObj = function(name, css, size, eleObjArr, $obj){
		this.name = name;
		if(!css){
			css = CSS_DEFAULT;
		}
		this.css = css;
		this.size = size;
		this.eleObjArr = eleObjArr;
		this.$obj = $obj;
	};
	
	return NavigationFun;
})();