
var Componet = (function(){
	
	/**
	 * @param _KEY_COMP	标识组件的标签名
	 * @param _KEY_LIST	标识list的标签名
	 * @param compName	组件名
	 * @param compObj	组件DOM对象
	 * @param data		后台JSON处理后返回的数据源
	 */
	this._KEY_COMP = "data-comp";
	this._KEY_LIST = "data-comp-list";
	this.compName;
	this.compObj;
	this.data;
	
	/**
	 * 组件调用方法构造函数
	 */
	var ComponetFun = function(){};
	
	/**
	 * 事件绑定
	 */
	var bindEvent = function(){};
	
	/**
	 * 组建初始化
	 * @param compName			组件名
	 * @param postUrl			请求路径
	 * @param postParam			请求参数
	 * @returns {ComponetFun}	返回可调用的方法对象
	 */
	ComponetFun.prototype.init = function(compName, postUrl, postParam){
		this.compName = compName;
		getCompObj(compName);
		getServiceData(postUrl, postParam);
		return this;
	};
	
	/**
	 * 销毁对象
	 */
	ComponetFun.prototype.destory = function(){};

	/**
	 * 渲染处理
	 */
	ComponetFun.prototype.rander = function(){
		// 数据渲染
		modelRander();
		// 视图渲染
		viewRander();
	};
	
	
	/**
	 * 数据渲染
	 * @param matchArr	匹配到的数组
	 */
	var modelRander = function(){
		// 判断是否是list
		var isList = false;
		var listObj = this.compObj.find("div["+_KEY_LIST+"]");
		if(listObj && listObj.length > 0){
			isList = true;
		}
		if(isList){
			dealListData(listObj,this.data);
		}else{
			dealSimpleData();
		}
	};
	
	/**
	 * 视图渲染
	 */
	var viewRander = function(){
		this.compObj.show();
	};
	
	
	/**
	 * 处理simple形式的数据
	 */
	var dealSimpleData = function(){
		// 模版html
		var htmlStr = this.compObj.html();
		// 删除模版
		this.compObj.empty();
		// 匹配结果
		var keyArr = matchKey(htmlStr);
		if(!keyArr){
			return;
		}
		var rstHtml = replaceTempHtml(htmlStr, this.data, keyArr);
		compObj.append(rstHtml);
	};
	
	/**
	 * 处理list形式的数据
	 * @param listObj	list对象
	 * @param dataObj	数据对象
	 */
	var dealListData = function(listObj,dataObj){
		// 多个data-list 循环遍历
		listObj.each(function(){
			// 模版html
			var htmlStr = $(this).html();
			// 删除模版
			$(this).empty();
			// 匹配结果
			var keyArr = matchKey(htmlStr);
			if(!keyArr){
				return;
			}
			// 用于替换的数据对象
			var listDataObj = null;
			// 后台数据名
			var listVal = $(this).attr(_KEY_LIST);
			// 获取数据
			try{
				eval("listDataObj = dataObj."+listVal+";");
			}catch(e){
				console.log(e);
			}
			if(!listDataObj){
				console.log("属性:" + listVal + " 的值在json处理后的data中不存在");
			}
			for(var m in listDataObj){
				var rstHtml = replaceTempHtml(htmlStr, listDataObj[m], keyArr);
				$(this).append(rstHtml);
			}
		});
	};
	
	/**
	 * 根据后台数据替换模版html
	 * @param 	tmpHtml		模版html
	 * @param 	data		替换用的数据
	 * @param 	matchArr	匹配到的关键字数组
	 * @returns tmpHtml		返回替换处理后的html
	 */
	var replaceTempHtml = function(tmpHtml, data, matchArr){
		for(var i in matchArr){
			var property = matchArr[i].replace("@{","").replace("}","");
			var propertyVal = null;
			try{
				eval("propertyVal = data."+property+";");
			}catch(e){
				console.log(e);
			}
			if(!propertyVal){
				console.log("属性:"+property+" 的值在json处理后的data中不存在");
				propertyVal = "";
			}
			tmpHtml = tmpHtml.replace(matchArr[i], propertyVal);
		}
		return tmpHtml;
	};
	
	/**
	 * 获取服务器数据
	 * @param postUrl	请求路径
	 * @param postParam	请求参数
	 */
	var getServiceData = function(postUrl, postParam){
		var json = post(postUrl, postParam);
		if(json && json.result){
			this.data = json.result;
		}else{
			console.log("json字符串解析错误");
		}
	};
	
	/**
	 * 根据组件名查找对象
	 * @param compName	组件名
	 */
	var getCompObj = function(compName){
		this.compObj  = $("div["+_KEY_COMP+"='"+compName+"']");
		if(!this.compObj){
			console.log("找不到该组件名:" + compName);
		}
	};
	
	/**
	 * 匹配目标范围中@{}关键词
	 */
	var matchKey = function(str){
		if(!str){
			return null;
		}
		var rsArr = new Array();
		var regexp = "@{[^\{\}]+}";
		var rs = str.match(regexp);
		while(rs){
			rsArr.push(rs[0]);
			var index = rs.index + rs[0].length;
			str = str.substring(index);
			rs = str.match(regexp);
		}
		return rsArr;
	};
	
	return ComponetFun;
})();