var NavigationBase = $.extend({}, RichBase, {
	
	_KEY_NAV_TITLE 		: "data-nav-title",
	_KEY_NAV_ACTIVE		: "data-nav-isAct",
	_KEY_NAV_TARGET_ID	: "data-nav-tarId",
	_KEY_NAV_PARAMS		: "data-nav-params",
	_KEY_NAV_ISALL		: "data-nav-isAll",
	_KEY_NAV_URL		: "data-nav-url",
	_KEY_NAV_TARURL		: "data-nav-tarUrl",
	_KEY_NAV_TARGET		: "data-nav-target",
	_KEY_NAV_USETEMP	: "data-nav-usetemp",
	
	_CSS_DEFAULT		: "nav",
	_CSS_ELE_ACTIVE		: "active",
	
	events : {
		"div[data-nav-tarId]" : {
			click : function(self,e){
				e.target && self._doChgEle(e.target);
			}
		}
	},
	
	// click 后触发的事件 切换目标结点
	_doChgEle : function(target){
		var self = this;
		self._clearAllActive(target);
		$(target).addClass(self._CSS_ELE_ACTIVE);
		self._hideAllTarget();
		self._showTargetItem($(target).attr(self._KEY_NAV_TARGET_ID));
	},
	
	// 清除所有active样式
	_clearAllActive : function(){
		var self = this;
		var navObj = self.get("navObj");
		
		for(var i in navObj.eleObjArr){
			var thisEleObj = navObj.eleObjArr[i].$obj;
			thisEleObj.removeClass(self._CSS_ELE_ACTIVE);
		}
	},
	
	// 隐藏所有目标结点
	_hideAllTarget : function(){
		var self = this;
		var navObj = self.get("navObj");
		
		for(var i in navObj.eleObjArr){
			$("#" + navObj.eleObjArr[i].targetId).hide();
		}
	},
	
	// 显示目标结点
	_showTargetItem : function(targetId){
		$("#" + targetId).show();
	},
	
	// 获取导航栏jquery对象
	_getNav$Obj : function(){
		var self = this;
		return $("div[" + self._KEY_NAV_TITLE + "='" + self.get("navName") + "']") || {};
	},
	
	// 获取导航栏目标jquery对象
	_getNav$TarObj : function(){
		var self = this;
		return $("div[" + self._KEY_NAV_TARGET + "='" + self.get("navName") + "']") || {};
	},
	
	// 获取导航栏目标子元素对象数组
	_getNavTarEleObjArr : function(navTarObj){
		var self = this;
		var tempArr = new Array();
		navTarObj.children().each(function(){
			var id = $(this).attr("id");
			var navTarEleObj = self.NavTarEleObj(id, $(this), false);
			tempArr.push(navTarEleObj);
		});
		return tempArr || {};
	},
	
	// 获取导航栏子元素对象数组
	_getNavEleObjArr : function(navObj){
		var self = this;
		var tempArr = new Array();
		navObj.find("[" + self._KEY_NAV_TARGET_ID + "]").each(function(){
			var name = $(this).text();
			var targetId = $(this).attr(self._KEY_NAV_TARGET_ID);
			var isActive = $(this).attr(self._KEY_NAV_ACTIVE) ? true : false;
			var params = $(this).attr(self._KEY_NAV_PARAMS);
			var navEleObj = self.NavEleObj(name, targetId, isActive, $(this), params);
			tempArr.push(navEleObj);
		});
		return tempArr || {};
	},
	
	// 导航栏目标对象的构造函数
	NavTarObj : function(name, tarEleObjArr, $obj, postUrl, useTemp, template, content){
		var self = this;
		return {
			"name"			: name,
			"tarEleObjArr"	: tarEleObjArr,
			"$obj"			: $obj,
			"postUrl"		: self.get("tarPostUrl") || postUrl || false,
			"useTemp"		: self.get("useTemp") || useTemp || false,
			"template"		: self.get("template") || template || false,
			"content"		: self.get("content") || content || false
		};
	},
	
	// 导航栏目标对象子元素构造函数
	NavTarEleObj : function(id, $obj, isload){
		return {
			"id"			: id,
			"$obj"			: $obj,
			"isload"		: isload
		};
	},
	
	// 导航栏子元素构造函数
	NavEleObj : function(name, targetId, isActive, $obj, params){
		var self = this;
		return {"name" 		: name,
				"targetId"	: targetId,
				"isActive"	: isActive,
				"$obj" 		: $obj,
				"params"	: self._str2JsonObj(params) || false
		};
	},
	
	// 导航栏对象构造函数
	NavObj : function(name, css, size, eleObjArr, $obj, postUrl, isAll){
		var self = this;
		return {"name" 		: name,
				"css" 		: self.get("css") || css || self._CSS_DEFAULT,
				"size"		: size,
				"eleObjArr"	: eleObjArr,
				"$obj"		: $obj,
				"postUrl"	: self.get("postUrl") || postUrl || false,
				"isAll"		: self.get("isAll") || isAll || false,
		};
	},
	
	
	// 重写子类方法 设置事件绑定的父节点
	_setParentNode : function(){
		var self = this;
		self._getNav$Obj() && self.set(self.parentNode, self._getNav$Obj());
	},
	
	// 初始化 导航栏对象
	_initNavObj : function(){
		var self = this;
		
		var $navObj = self._getNav$Obj();
		var eleObjArr = self._getNavEleObjArr($navObj);
		var size = eleObjArr.length || 0;
		var isAll = $navObj.attr(self._KEY_NAV_ISALL);
		var postUrl = $navObj.attr(self._KEY_NAV_URL);
		var tarUrl = $navObj.attr(self._KEY_NAV_TARURL);
		var navObj = self.NavObj(self.get("navName"), self.get("css"), size, eleObjArr, $navObj, postUrl, tarUrl, isAll);
		return navObj || {};
	},
	
	// 初始化 导航栏目标对象
	_initNavTarObj : function(){
		var self = this;
		
		var $navTarObj = self._getNav$TarObj();
		var tarEleObjArr = self._getNavTarEleObjArr($navTarObj);
		var postUrl = $navTarObj.attr(self._KEY_NAV_URL);
		var useTemp = $navTarObj.attr(self._KEY_NAV_USETEMP);
		var navTarObj = self.NavTarObj(self.get("navName"), tarEleObjArr, $navTarObj, postUrl, useTemp, $navTarObj.html(), $navTarObj.children().html());
		return navTarObj || {};
	},
	
	// 处理导航栏第一次显示
	_initFirstShow : function(){
		var self = this;
		
		var navObj = self.get("navObj");
		
		for(var i in navObj.eleObjArr){
			if(navObj.eleObjArr[i].isActive){
				self._hideAllTarget();
				self._showTargetItem(navObj.eleObjArr[i].targetId);
				continue;
			}
		}
	},
	
	// 组件业务逻辑实现方法
	render : function(){
		var self = this;
		
		var navObj = self._initNavObj();
		
		var navTarObj = self._initNavTarObj();
		
		// 放入config中 后面可以获取
		self.set("navObj", navObj);
		self.set("navTarObj", navTarObj);
		
	}
});