(function(window){
	
var NavigationTrans = $.extend({}, NavigationBase, {
	
	cssObj	:	{ 
		cssItem		: "-ele-item",
		cssEle		: "-ele",
		cssPaddingL	: "-padding-left",
		cssPaddingR	: "-padding-right",
		cssEleCount	: "-ele-"
	},
	
	template : 		"<div class = '@{paddingL}'></div>" +
						"<div class = '@{ele} @{eleCount}'>@{items}</div>" +
					"<div class = '@{paddingR}'></div>",
	
	setup : function(){
		var self = this;
		
		self.render();
		
		var nav$Obj = self._getNav$Obj();
		self._setCss();
		
		
		// 给item增加 item样式
		nav$Obj.children().each(function(){
			$(this).addClass(self.cssObj.cssItem);
		});
		
		var newHtmlNode = self._parseTemplate(self.template, {
			"items"		: nav$Obj.html(),
			"paddingL"	: self.cssObj.cssPaddingL,
			"paddingR"	: self.cssObj.cssPaddingR,
			"ele"		: self.cssObj.cssEle,
			"eleCount"	: self.cssObj.cssEleCount
		});
		
		nav$Obj.empty();
		nav$Obj.append(newHtmlNode);
		
		// 重新设置修改后的子元素数组
		var navObj = self.get("navObj");
		navObj.eleObjArr = self._getNavEleObjArr(nav$Obj);
		self.set("navObj", navObj);
		
		self._initFirstShow();
	},

	_setCss : function(){
		var self = this;
		var navObj = self.get("navObj");
		for(var key in self.cssObj){
			self.cssObj[key] = navObj.css + self.cssObj[key];
		}
		
		// 处理 item总数量样式
		self.cssObj.cssEleCount = self.cssObj.cssEleCount + (navObj.size?navObj.size + "" : "1");
	}
	
});

// 返回构造函数
var NavTrans = function(config){
	NavigationTrans.init(config);
};

if ( typeof module != 'undefined' && module.exports ) {
	module.exports = NavTrans;
}else {
	window.NavTrans = NavTrans;
}

})(window);