(function(window, jQuery) {
	
var NavigationVertical = $.extend({}, DataRender, NavigationBase, {

	_KEY_NAV_FOR : "data-nav-for",
	_KEY_NAV_TAR : "data-nav-target",
	_KEY_NAV_LIST: "data-nav-list",
	
	cssObj : {
		cssVer 		: "nav-ver",
		cssVerEle	: "nav-ver-ele",
		cssVerTarget: "nav-ver-target"
	},
	
	events : {
		"div" : {
			click : function(self,e){
				if(!e || !e.target) return;
				var navTarObj = self.get("navTarObj");
				var navEle$Obj = $(e.target);
				var targetId = navEle$Obj.attr(self._KEY_NAV_TARGET_ID);
				if(!targetId) return;
				var params = navEle$Obj.attr(self._KEY_NAV_PARAMS);
				self._dealDataRender2navTar(navTarObj.postUrl, self._str2JsonObj(params), targetId);
				self._doChgEle(e.target);
			}
		}
	},
	
	// 重写base类中清除所有active样式
	_clearAllActive : function(target){
		var self = this;
		$(target).parent().children().each(function(){
			$(this).removeClass(self._CSS_ELE_ACTIVE);
		});
	},
	
	templateAll : "<div data-nav-tarId = '@{targetId}' data-nav-isAct = '@{isActive}'>@{text}</div>",
	templateTar	: "",
	
	setup : function() {
		var self = this;
		self.render();
		
		var navObj = self.get("navObj");
		var navTarObj = self.get("navTarObj");
		
		// 是否要显示<全部>一栏
		navObj.isAll && self._appendTemplateAll();
		// 导航目标是否使用模版
		navTarObj.useTemp && self._dealTemp2TarObj();
		// 加载样式
		self._loadCss();
		// 处理第一次显示
		self._initFirstShow();
		
		// 重新设置html 用来支持IScroll
		var nav$Obj = navObj.$obj;
		nav$Obj.html(self._resetHtml2IScroll(nav$Obj.html()));
		// 给导航栏添加IScroll功能
		self._addIScroll("["+self._KEY_NAV_TITLE+"='"+navObj.name+"']", {
		    mouseWheel: true,
		    scrollbars: false,
		    click:true,
		});
		
	},
	
	// 加载样式
	_loadCss : function(){
		var self = this;
		var nav$Obj = self._getNav$Obj();
		var navTar$Obj = self._getNav$TarObj();
		nav$Obj.addClass(self.cssObj.cssVer);
		nav$Obj.children().each(function(){
			$(this).addClass(self.cssObj.cssVerEle);
		});
		navTar$Obj.addClass(self.cssObj.cssVerTarget);
	},
	
	// 重写base中 处理导航栏第一次显示 的函数
	_initFirstShow : function(){
		var self = this;
		
		var navObj = self.get("navObj");
		var navTarObj = self.get("navTarObj");
		
		for(var i in navObj.eleObjArr){
			if(navObj.eleObjArr[i].isActive){
				var targetId = navObj.eleObjArr[i].targetId;
				var params = navObj.eleObjArr[i].params;
				
				self._hideAllTarget();
				// 设置active样式
				$("[" + self._KEY_NAV_TARGET_ID + "='" + targetId + "']").addClass(self._CSS_ELE_ACTIVE);
				// 导航栏目标数据渲染
				self._dealDataRender2navTar(navTarObj.postUrl, params, targetId);
				// 显示导航栏目标
				self._showTargetItem(targetId);
				return;
			}
		}
		return;
	},
	
	// 重写DataRender 中 获取list对象的方法
	_getListObj : function(navTarEle$Obj){
		var self = this;
		
		return navTarEle$Obj.find("div["+self._KEY_NAV_LIST+"]") || null;
	},
	
	// 根据targetId 找到 navTarEleObj
	_getNavTarEleObj : function(targetId){
		var self = this;
		
		var navTarObj = self.get("navTarObj");
		for(var i in navTarObj.tarEleObjArr){
			var tarEleObj = navTarObj.tarEleObjArr[i];
			if(tarEleObj.id === targetId){
				return tarEleObj;
			}
		}
		return null;
	},
	
	_getNavTarEleObjIndex : function(tarEleObj){
		var self = this;
		
		var navTarObj = self.get("navTarObj");
		for(var i in navTarObj.tarEleObjArr){
			var tempTarEleObj = navTarObj.tarEleObjArr[i];
			if(tempTarEleObj.id === tarEleObj.id){
				return i;
			}
		}
	},
	
	// 导航栏目标数据渲染
	_dealDataRender2navTar : function(url, params, targetId) {
		var self = this;
		
		var tarEleObj = self._getNavTarEleObj(targetId);
		// 判断对象是否存在 并且还没有加载过
		if(!tarEleObj || tarEleObj.isload) return;
		var tarEle$Obj = tarEleObj.$obj;

		var data = self._getServiceData(url, params);
		if(!data) return;
		
		var isList = false;
		// 判断组件是list形式还是simple形式
		var list$Obj = self._getListObj(tarEle$Obj);
		if(list$Obj && list$Obj.length > 0) isList = true;
		
		if(isList){
			self._doDealListData(list$Obj, self._KEY_NAV_LIST, data);
		}else{
			self._doDealSimpleData(tarEle$Obj, data);
		}
		
		// 设置该子元素为已加载
		tarEleObj.isload = true;
		var index = self._getNavTarEleObjIndex(tarEleObj);
		var navTarObj = self.get("navTarObj");
		navTarObj.tarEleObjArr[index] = tarEleObj;
		self.set("navTarObj", navTarObj);
	},
	
	// 给导航栏目标处理模版
	_dealTemp2TarObj : function(){
		var self = this;
		
		var navObj = self.get("navObj");
		var navTarObj = self.get("navTarObj");
		var navTar$Obj = navTarObj.$obj;
		
		if(!navTarObj || navTarObj.length > 1) return;
		
		// 获取导航栏目标的模版对象
		var navTarEle$Obj = navTarObj.tarEleObjArr[0].$obj;
		// 清空内容
		navTarEle$Obj.empty();
		// 保存去除内容后的模版
		navTarObj.template = navTar$Obj.html();
		// 清除模版
		navTar$Obj.empty();
		
		// 根据导航栏targetId 自动生成目标结点
		for(var i in navObj.eleObjArr){
			var targetId = navObj.eleObjArr[i].targetId;
			var newHtmlNode = self._parseTemplate(navTarObj.template, {"targetId":targetId});
			// 把去除的原内容 放回去
			var newNode$Obj = $(newHtmlNode);
			newNode$Obj.html(navTarObj.content);
			navTar$Obj.append(self._html(newNode$Obj));
		}
		// 重新设置导航栏元素数组的值
		navTarObj.tarEleObjArr = self._getNavTarEleObjArr(navTar$Obj);
		self.set("navTarObj", navTarObj);
	},
	
	// 添加显示全部的选项
	_appendTemplateAll : function()	{
		
	},
	
	// 修改html 支持IScroll
	_resetHtml2IScroll : function(html){
		return "<div>" + html + "</div>";
	},
	
	// 增加IScroll的功能
	_addIScroll : function(selector, params){
		new IScroll(selector, params);
	}
});


var NavVertical = function(config) {
	NavigationVertical.init(config);
};

if (typeof module != 'undefined' && module.exports) {
	module.exports = NavVertical;
} else {
	window.NavVertical = NavVertical;
}

})(window, jQuery);