/**
 * 初始化toggleButton控件
 * @param enabledTxt [optional]toggle button值为运行提交的提示文本,enabledTxt不为空以此值,否则默认为:"是"
 * @param disabledTxt [optional]toggle button值为不提交表单的提示文本,disabledTxt不为空以此值,否则默认为:"否"
 * @param checkboxId [optional] 对哪个checkbox渲染成toggle button的父容器div id,如果该值为空则查找<div class="basic-toggle-button">包含的checkbox表单且class="toggle"
 */
function initToggleButtons(enabledTxt,disabledTxt,checkboxId)
{
	if (!jQuery().toggleButtons) {
        return;
    }
	
	enabledTxt=(typeof(enabledTxt)=="undefined" || enabledTxt.length==0)?"是":enabledTxt;
	disabledTxt=(typeof(disabledTxt)=="undefined" || disabledTxt.length==0)?"否":disabledTxt;
	if(checkboxId)
	{
		$('#'+checkboxId).toggleButtons({
			"label": {
				"enabled": enabledTxt,
				"disabled": disabledTxt
			}
		});	
	}
	else
	{
		$('.basic-toggle-button').toggleButtons({
            "label": {
				"enabled": enabledTxt,
				"disabled": disabledTxt
            }
        });
	}
}

/**
 * 初始化select2控件
 * @param selectId[可选] 如无selectId参数则寻找select样式为:select2-flag的类自动渲染
 * @param placeholder[可选]
 */
function initSelect2(selectId,placeholder)
{
	if (selectId=="" || (typeof selectId!="undefined" && $("#"+selectId).length==0)) {
        return;
    }
	placeholder=(typeof placeholder=="undefined")?"请选择":placeholder;
	if(typeof selectId!="undefined")
	{
		$('#'+selectId).select2({
	        "placeholder": placeholder,
	        "allowClear": true
	    });
	}
	else
	{
		$(".select2-flag").select2({
	        "placeholder": placeholder,
	        "allowClear": true
	    });
	}
}