var _QuotaExceededError_=null;
var SeedoCache=function(){
//	alert("storage:Obj" + localStorage + "|" + localStorage.setItem);
	if(typeof window.localStorage != "object")
	{
		return {"isSupport":false};
	}
	return {
		"isSupport":true,
		/*
		 * 保存key对应的val值到缓存中,val是一般的字符串值.
		 */
		"putVal":function(key,val)
		{
			if(!key || !val)
			{
				return false;
			}
			var jsonstr="{\"expires\":-1,\"value\":{0}}";
			if(typeof val=="string")
			{
				jsonstr="{\"expires\":-1,\"value\":\"{0}\"}";
				if(val.indexOf("{")==0 && val.lastIndexOf("}")==val.length-1
						&& val.indexOf("\"expires\"")>0 && val.indexOf("\"value\"")>0)
				{
					jsonstr=val;
					val="";
				}
			}
			else if(typeof val=="object")
			{
				jsonstr="{\"expires\":-1,\"value\":{0}}";
				val=JSON.stringify(val);
				if(val.indexOf("{")==0 && val.lastIndexOf("}")==val.length-1
						&& val.indexOf("\"expires\"")>0 && val.indexOf("\"value\"")>0)
				{
					jsonstr=val;
					val="";
				}
			}
			jsonstr=jsonstr.replace("{0}", val);
			try
			{
				localStorage.setItem(key, jsonstr);
				if(typeof jsonstr=="string" && localStorage.getItem(key)==null){
					alert("无法保存本地数据  key为:"+key);
					return false;
				}
			}
			catch (e) 
			{
				var errMsg = e.toString();
				if(errMsg.indexOf("QuotaExceededError")>0)
				{
					if(_QuotaExceededError_==null)
					{
						alert("无法保存本地数据，请关闭浏览器的无痕浏览模式！");
						_QuotaExceededError_=true;
					}
					console.log("无法保存本地数据，请关闭浏览器的无痕浏览模式！"+e);
					return false;
				}
				console.log("error:"+e);
				this.putVal("_ERROR_", e.message);
				this.setTimeout("_ERROR_", ((new Date()).getTime()+24*60*60*1000)/1000 );
				alert("error: 无法保存本地数据  key为:"+key);
				return false;
			}
			return true;
		},
		/*
		 * 获取缓存中key对应的值,存在返回字符串值,否则返回null
		 */
		"getVal":function(key)
		{
			if(!key || !localStorage.getItem(key) || localStorage.getItem(key)==null)
			{
				return null;
			}
			var valJson=JSON.parse(localStorage.getItem(key));
			if(!valJson)
			{
				return null;
			}
			if(valJson.expires && valJson.expires!=-1 && valJson.expires<(new Date()).getTime()/1000)
			{
				try
				{
					localStorage.removeItem(key);
					return null;
				}
				catch (e) 
				{
					console.log("getVal()->无法删除本地数据:"+e);
					this.putVal("_ERROR_", "getVal()->无法删除本地数据:"+e.message);
					this.setTimeout("_ERROR_", ((new Date()).getTime()+24*60*60*1000)/1000 );
					return null;
				}
			}
			return valJson.value;
		},
		/*
		 * 删除缓存key中的值.
		 */
		"remove":function(key)
		{
			try
			{
				localStorage.removeItem(key);
				return null;
			}
			catch (e) 
			{
				console.log("无法清除所有本地数据:"+e);
				this.putVal("_ERROR_", "无法清除所有本地数据:"+e.message);
				this.setTimeout("_ERROR_", ((new Date()).getTime()+24*60*60*1000)/1000 );
				return null;
			}
		},
		/*
		 * 删除全部缓存内容.
		 */
		"removeAll":function()
		{
			localStorage.clear();
		},
		/*
		 * 设置缓存key对应的值的过期时间.以秒为单位
		 */
		"setTimeout":function(key,second,currentServerTime)
		{
//				if(typeof key!="string" || typeof second!="number")
			if(typeof key!="string" || isNaN(second))
			{
				return false;
			}
			
			second = Number(second);
			
			if(!second || second<-1)
			{
				second=-1;
			}
			
			var obj=JSON.parse(localStorage.getItem(key));
			if(!obj)
			{
				return false;
			}
			if(obj.expires)
			{
				var cd=new Date();
				if(currentServerTime && typeof currentServerTime == "number")
				{
					cd=new Date(currentServerTime);
				}
				obj.expires=cd.getTime()/1000+second;
				this.putVal(key, obj);
			}
			return true;
		},
		/*
		 * 判断key是否在缓存中,是返回true否则false.
		 */
		"existKey":function(key)
		{
			if(localStorage.getItem(key))
			{
				return true;
			}
			return false;
		},
		"removeLike":function(likeKey)
		{
			var len=localStorage.length;
			var regEx=new RegExp(likeKey,"ig");
			for(var i=0;i<len;i++)
			{
				var keyName=localStorage.key(i);
				if(regEx.test(keyName))
				{
					localStorage.removeItem(keyName);
				}
			}
		}
	};
}();

function clearAllCache()
{
	var _PLATFORM_CUR_VER_KEY="platform.cur.ver";
	var LOCATION_URL_KEY="_locationURL_";
	var PLATFORM_KEY="platform";
	var IGNORE_VER_KEY = "is_ignore_ver_check";
	
	var ver=SeedoCache.getVal(_PLATFORM_CUR_VER_KEY);
	var curURL=SeedoCache.getVal(LOCATION_URL_KEY);
	var platform = SeedoCache.getVal(PLATFORM_KEY);
	var isIgnore = SeedoCache.getVal(IGNORE_VER_KEY);
	
	SeedoCache.removeAll();
	
	SeedoCache.putVal(_PLATFORM_CUR_VER_KEY,ver);
	SeedoCache.putVal(PLATFORM_KEY,platform);
	SeedoCache.putVal(LOCATION_URL_KEY,curURL);
	SeedoCache.putVal(IGNORE_VER_KEY,isIgnore);
}
