var _QuotaExceededError_=null;
var SessionCache=function(){
	if(typeof window.sessionStorage != "object")
	{
		return {"isSupport":false};
	}
	
	return {
		"isSupport":true,
		/*
		 * 保存key对应的val值到缓存中,val是一般的字符串值.
		 */
		"putVal":function(key,val)
		{
			if(!key || !val)
			{
				return false;
			}
			var jsonstr="{\"expires\":-1,\"value\":{0}}";
			if(typeof val=="string")
			{
				jsonstr="{\"expires\":-1,\"value\":\"{0}\"}";
				if(val.indexOf("{")==0 && val.lastIndexOf("}")==val.length-1
						&& val.indexOf("\"expires\"")>0 && val.indexOf("\"value\"")>0)
				{
					jsonstr=val;
					val="";
				}
			}
			else if(typeof val=="object")
			{
				jsonstr="{\"expires\":-1,\"value\":{0}}";
				val=JSON.stringify(val);
				if(val.indexOf("{")==0 && val.lastIndexOf("}")==val.length-1
						&& val.indexOf("\"expires\"")>0 && val.indexOf("\"value\"")>0)
				{
					jsonstr=val;
					val="";
				}
			}
			jsonstr=jsonstr.replace("{0}", val);
			try
			{
				sessionStorage.setItem(key, jsonstr);
			}
			catch (e) 
			{
				var errMsg = e.toString();
				if(errMsg.indexOf("QuotaExceededError")>0)
				{
					if(_QuotaExceededError_==null)
					{
						alert("无法保存本地数据，请关闭浏览器的无痕浏览模式！");
						_QuotaExceededError_=true;
					}
					console.log("无法保存本地数据，请关闭浏览器的无痕浏览模式！"+e);
					return false;
				}
				console.log("error:"+e);
				this.putVal("_ERROR_", e.message);
				this.setTimeout("_ERROR_", ((new Date()).getTime()+24*60*60*1000)/1000 );
				return false;
			}
			return true;
		},
		/*
		 * 获取缓存中key对应的值,存在返回字符串值,否则返回null
		 */
		"getVal":function(key)
		{
			if(!key || !sessionStorage.getItem(key) || sessionStorage.getItem(key)==null)
			{
				return null;
			}
			var valJson=JSON.parse(sessionStorage.getItem(key));
			if(!valJson)
			{
				return null;
			}
			if(valJson.expires && valJson.expires!=-1 && valJson.expires<(new Date()).getTime()/1000)
			{
				try
				{
					sessionStorage.removeItem(key);
					return null;
				}
				catch (e) 
				{
					console.log("getVal()->无法删除本地数据:"+e);
					this.putVal("_ERROR_", "getVal()->无法删除本地数据:"+e.message);
					this.setTimeout("_ERROR_", ((new Date()).getTime()+24*60*60*1000)/1000 );
					return null;
				}
			}
			return valJson.value;
		},
		/*
		 * 删除缓存key中的值.
		 */
		"remove":function(key)
		{
			try
			{
				sessionStorage.removeItem(key);
				return null;
			}
			catch (e) 
			{
				console.log("无法清除所有本地数据:"+e);
				this.putVal("_ERROR_", "无法清除所有本地数据:"+e.message);
				this.setTimeout("_ERROR_", ((new Date()).getTime()+24*60*60*1000)/1000 );
				return null;
			}
		},
		/*
		 * 删除全部缓存内容.
		 */
		"removeAll":function()
		{
			sessionStorage.clear();
		},
		/*
		 * 设置缓存key对应的值的过期时间.以秒为单位
		 */
		"setTimeout":function(key,second,currentServerTime)
		{
			if(typeof key!="string" || typeof second!="number")
			{
				return false;
			}
			if(!second || second<-1)
			{
				second=-1;
			}
			
			var obj=JSON.parse(sessionStorage.getItem(key));
			if(!obj)
			{
				return false;
			}
			if(obj.expires)
			{
				var cd=new Date();
				if(currentServerTime && typeof currentServerTime == "number")
				{
					cd=new Date(currentServerTime);
				}
				obj.expires=cd.getTime()/1000+second;
				this.putVal(key, obj);
			}
			return true;
		},
		/*
		 * 判断key是否在缓存中,是返回true否则false.
		 */
		"existKey":function(key)
		{
			if(sessionStorage.getItem(key))
			{
				return true;
			}
			return false;
		},
		"removeLike":function(likeKey)
		{
			var len=sessionStorage.length;
			var regEx=new RegExp(likeKey,"ig");
			for(var i=0;i<len;i++)
			{
				var keyName=sessionStorage.key(i);
				if(regEx.test(keyName))
				{
					sessionStorage.removeItem(keyName);
				}
			}
		}
	};
}();
